// -*-C++-*- include/cool/algorithm/next.hpp
// ----------------------------------------------------------------------- 
//  Copyright  2002 Dietmar Khl, All Rights Reserved                     
//                                                                         
//  Permission to use, copy, modify, distribute and sell this              
//  software for any purpose is hereby granted without fee, provided       
//  that the above copyright notice appears in all copies and that         
//  both that copyright notice and this permission notice appear in        
//  supporting documentation. Dietmar Khl makes no representations about  
//  the suitability of this software for any purpose. It is provided       
//  "as is" without express or implied warranty.                           
// ----------------------------------------------------------------------- 

// Author:  Dietmar Kuehl http://www.dietmar-kuehl.de 
// Title:   the next() algorithm
// Version: $Id: next.hpp,v 1.1.1.1 2003/01/07 00:15:08 kuehl Exp $ 

// ----------------------------------------------------------------------- 

#if !defined(COOL_ALGORITHM_NEXT_HPP)
#define COOL_ALGORITHM_NEXT_HPP 1

namespace cool
{

  // ------------------------------------------------------------------------
  //-dk:TODO: move to the correct place: prev()

  template <typename BidirectionalIterator>
  inline BidirectionalIterator
  prev(BidirectionalIterator it)
  {
    return --it;
  }

  // ------------------------------------------------------------------------

  template <typename InputIterator>
  inline InputIterator
  next(InputIterator it)
  {
    return ++it;
  }

  // ------------------------------------------------------------------------

} // namespace cool

#endif /* COOL_ALGORITHM_NEXT_HPP */
